#!/usr/local/bin/python

import socket
import urllib
import string
import getpass

if not hasattr(socket, "ssl"):
    raise "socket module has no ssl support"

class BackupConfiguration:
    
    def __init__(self):
        self._ftp_location = ""
        self._ftp_password = ""
        self._ftp_username = ""
        self._ftp_server = ""
        self._email = ""
        self._sites = []

    def ftp_location(self, ftp_location=None):
        if ftp_location == None:
            return self._ftp_location
        else:
            self._ftp_location = ftp_location

    def ftp_password(self, ftp_password=None):
        if ftp_password == None:
            return self._ftp_password
        else:
            self._ftp_password = ftp_password

    def ftp_username(self, ftp_username=None):
        if ftp_username == None:
            return self._ftp_username
        else:
            self._ftp_username = ftp_username

    def ftp_server(self, ftp_server=None):
        if ftp_server == None:
            return self._ftp_server
        else:
            self._ftp_server = ftp_server

    def email(self, email=None):
        if email == None:
            return self._email
        else:
            self._email = email

    def sites(self, sites=None):
        if sites == None:
            return self._sites
        else:
            self._sites = sites

class Backup:
    def __init__(self, ocw_credential, host, backup_configuration):
        self._ocw_credential = ocw_credential
        self._backup_configuration = backup_configuration
        self._host = host

    def backup_configuration(self, backup_configuration=None):
        if backup_configuration == None:
            return self._backup_configuration
        else:
            self._backup_configuration = backup_configuration

    def ocw_credential(self, ocw_credential=None):
        if ocw_credential == None:
            return self._ocw_credential
        else:
            self._ocw_credential = ocw_credential

    def host(self, host=None):
        if host == None:
            return self._host
        else:
            self._host = host

    def perform(self):

        if socket.RAND_status() == 0:
            print "Adding to entropy"
            socket.RAND_add(
                "09a8sd09*A)SD(&()&)@#(7()WEW&()SD^C906sd09&)(SD^)9a6d09sa609d", 
                7503909.9098098)

        url = "https://%s:%s/webhost/services/vhbackup/manage_backup?" % (
                self.host().address(),
                self.host().admin_port())

        url += "ocw_login_username=%s&ocw_login_password=%s&ocw_lang=%s&" % (
                    self.ocw_credential().username(),
                    self.ocw_credential().password(),
                    self.host().language())

        url += "ftp_server=%s&ftp_username=%s&ftp_password=%s&" % (
                    self.backup_configuration().ftp_server(),
                    self.backup_configuration().ftp_username(),
                    self.backup_configuration().ftp_password())

        url += "ftp_password_confirm=%s&email=%s&" % (
                    self.backup_configuration().ftp_password(),
                    self.backup_configuration().email())

        url += "sitelist=%s&ftp_location=%s&submit=Backup" % (
                string.join(self.backup_configuration().sites(), ','),
                self.backup_configuration().ftp_location())

        print "Sending backup request to %s\n" % self.host().address()
        f = urllib.urlopen(url)
        #buf = f.read()
        #f.close()

if __name__ == '__main__':

    from model import *

    def input(prompt, default="none"):
        answer = raw_input(prompt + "? [" + default + "] ")
        if answer == "":
            answer = default
        return answer.strip()


    login = OCWCredential()
    login.username(input("Appliance admin username", "admin"))
    login.password(getpass.getpass('Admin password? '))

    host = EnsimHost()
    address = input('Appliance host name/IP address')
    host.address(address)
    host.admin_port(input('Admin port', '19638'))
    host.language(input('Language', 'en'))

    config = BackupConfiguration()
    config.ftp_username(input('backup username','vhbackup'))
    config.ftp_password(getpass.getpass('Ftp password? '))
    config.ftp_location(input('Backup directory', '/home/vhbackup/virtual'))
    config.ftp_server(input('Backup host','localhost'))
    config.email(input('Admin email (for report)', 'admin@' + address))
    config.sites(('all',))

    backup = Backup(login, host, config)
    backup.perform()

