#!/usr/bin/python

from ensim.backup import *
from ensim.model import *

if __name__ == '__main__':

    def input(prompt, default="none"):
        answer = raw_input(prompt + "? [" + default + "] ")
        if answer == "":
            answer = default
        return answer.strip()


    login = OCWCredential()
    login.username(input("Appliance admin username", "admin"))
    login.password(getpass.getpass('Admin password? '))

    host = EnsimHost()
    address = input('Appliance host name/IP address')
    host.address(address)
    host.admin_port(input('Admin port', '19638'))
    host.language(input('Language', 'en'))

    config = BackupConfiguration()
    config.ftp_username(input('backup username','vhbackup'))
    config.ftp_password(getpass.getpass('Ftp password? '))
    config.ftp_location(input('Backup directory', '/home/vhbackup/virtual'))
    config.ftp_server(input('Backup host','localhost'))
    config.email(input('Admin email (for report)', 'admin@' + address))
    config.sites(('all',))

    backup = Backup(login, host, config)
    backup.perform()

